// blood graph PDF by gnuplot ports from golang
// for Vlang
module main

import os
import encoding.csv
import flag
import strconv

const dbfile = 'current.csv'

struct AAy {
pub mut:
	bld [][]int // main data type
}

const ( // rows index name 0 .. 3
	ymdh = 0
	hi   = 1
	low  = 2
	pls  = 3
)

fn ag(path string) string { // for gnuplot option
	contents := os.read_file(path.trim_space()) or { panic(err) }
	return 'when=' + contents[..6]
}

fn csv_read(csvfile string) &AAy {
	mut sbld := &AAy{
		bld: [][]int{}
	}
	mut rows := []int{}
	mut data := os.read_file(csvfile) or { panic(err) }
	mut reader := csv.new_reader(data)
	for {
		el := reader.read() or { break }
		rows = []
		for v in el {
			rows << strconv.atoi(v) or { panic(err) }
		}
		sbld.bld << rows
	}
	return sbld
}

fn savecsv(csf string, ds AAy) {
	mut s := ''
	for _, v in ds.bld {
		s += strconv.v_sprintf('%d,%d,%d,%d\n', v[ymdh], v[hi], v[low], v[pls])
	}
	os.write_file(csf, s) or { panic(err) }
}

// add new data
fn ire(ym int, mut ds AAy) ? {
	mut rs := [0, 0, 0, 0]
	for {
		mut ar := os.input('$ym> ').split(' ')
		ar = ar.filter(it != '')
		if ar.len == 0 {
			continue
		}
		if ar[0] == 'fin' {
			break
		}
		if ar.len != 4 {
			println('Bad data len')
			continue
		}
		rs = [0, 0, 0, 0] // for tunnel bug go away
		rs[ymdh] = strconv.atoi(ar[0]) ?
		rs[hi] = strconv.atoi(ar[1]) ?
		rs[low] = strconv.atoi(ar[2]) ?
		rs[pls] = strconv.atoi(ar[3]) ?
		if rs[ymdh] < 100 || rs[ymdh] > 3123 || (rs[ymdh] % 100) > 23 || rs[hi] < 80 || rs[low] < 40
			|| rs[pls] < 40 {
			println('Bad data')
			continue
		}
		rs[ymdh] += (ym * 10000)
		if rs[ymdh] <= ds.bld[ds.len() - 1][ymdh] {
			println('Bad seq.')
			continue
		}
		ds.bld << rs
	}
	savecsv(dbfile, ds)
}

fn (ds AAy) len() int {
	return ds.bld.len
}

// pipe data to file
fn (ds AAy) pp(vfn string) ? {
	mut s := ''
	for _, el in ds.bld {
		s += strconv.v_sprintf('%d %d %d\n', el[ymdh], el[hi], el[low])
	}
	os.write_file(vfn, s) ?
}

// pipe filter head
fn (ds AAy) hd(n int) AAy {
	if ds.len() < n {
		println('Warn: Req size is to big, apply possible size.')
		return ds
	}
	mut rs := AAy{
		bld: [][]int{}
	}
	for _, el in ds.bld[..n] {
		rs.bld << el
	}
	return rs
}

// pipe filter tail
fn (ds AAy) tl(n int) AAy {
	if ds.len() < n {
		println('Warn: Req size is to big, apply possible size.')
		return ds
	}
	mut rs := AAy{
		bld: [][]int{}
	}
	for _, el in ds.bld[ds.len() - n..] {
		rs.bld << el
	}
	return rs
}

// pick am data for pipe
fn (ds AAy) am() AAy {
	mut rs := AAy{
		bld: [][]int{}
	}
	for _, el in ds.bld {
		if el[ymdh] % 100 < 12 {
			rs.bld << el
		}
	}
	return rs
}

// pick pm data for pipe
fn (ds AAy) pm() AAy {
	mut rs := AAy{
		bld: [][]int{}
	}
	for _, el in ds.bld {
		if el[ymdh] % 100 >= 12 {
			rs.bld << el
		}
	}
	return rs
}

// pipe filter from
fn (ds AAy) frm(ym int) AAy {
	mut rs := AAy{
		bld: [][]int{}
	}
	mut lmt := ym * 10000
	if ym > 9999 { // Case yymmdd
		lmt = ym * 100
	}
	for _, el in ds.bld {
		if el[ymdh] > lmt {
			rs.bld << el
		}
	}
	return rs
}

// until (not use)
fn (ds AAy) utl(ym int) AAy {
	mut rs := AAy{
		bld: [][]int{}
	}
	lmt := ym * 10000 + 3124
	for _, el in ds.bld {
		if el[ymdh] < lmt {
			rs.bld << el
		}
	}
	return rs
}

// equal (not use)
fn (ds AAy) eq(ym int) AAy {
	mut rs := AAy{
		bld: [][]int{}
	}
	for _, el in ds.bld {
		if el[ymdh] / 10000 == ym {
			rs.bld << el
		}
	}
	return rs
}

// make gnuplot script file
fn mksf(sf string) ? {
	gsrc := '# blood graph for gnuplot
set encoding utf8
set terminal pdfcairo mono font ",20" size 21cm, 29cm
set output "./" . when . ".pdf"
#set output "Desktop\\" . when . ".pdf"

stats "am.dat" using 2:3
amh = sprintf(" 最高血圧(平均=%.1f 偏差=%.1f)", STATS_mean_x, STATS_stddev_x)
aml = sprintf(" 最低血圧(平均=%.1f 偏差=%.1f)", STATS_mean_y, STATS_stddev_y)
stats "pm.dat" using 2:3
pmh = sprintf(" 最高血圧(平均=%.1f 偏差=%.1f)", STATS_mean_x, STATS_stddev_x)
pml = sprintf(" 最低血圧(平均=%.1f 偏差=%.1f)", STATS_mean_y, STATS_stddev_y)

set grid
set yrange [50:160]
set ytics 10
unset key                   # no label on right top
set xdata time
set timefmt "%y%m%d%H"
set format x "%m/%d"        # m/d/y -> m/d

set multiplot layout 2,1

set title  \'起床時: \' . amh . aml . when
plot "am.dat" using 1:2 with lines lt -1, "am.dat" using 1:3 with lines lt -1

set title  \'就寝時: \' . pmh . pml . when
plot "pm.dat" using 1:2 with lines lt -1, "pm.dat" using 1:3 with lines lt -1

unset multiplot
set terminal dumb
## end of gnuplot-script
'
	os.write_file(sf, gsrc) ?
}

// exec shell (this run on unix, windows can not run)
fn exec(args []string) {
	pid := os.fork()
	if pid > 0 {
		os.wait()
		return
	} else {
		os.execve('/bin/sh', args, []) or { panic(err) }
		// NO REACH HERE
	}
}

fn main() {
	mut fp := flag.new_flag_parser(os.args)
	vire := fp.int('ire', `i`, 1811, "Input YYMM's data")
	stym := fp.int('from', `f`, 1302, 'Make PDF at YYMM[DD]')

	mut abld := csv_read(dbfile)

	if vire != 1811 {
		ire(vire, mut abld) ?
	}

	sz := 14 // a week to 10 week's
	if stym <= 1302 {
		abld.am().tl(sz).pp('am.dat') ?
		abld.pm().tl(sz).pp('pm.dat') ?
	} else {
		abld.am().frm(stym).hd(sz).pp('am.dat') ?
		abld.pm().frm(stym).hd(sz).pp('pm.dat') ?
	}

	mksf('topdf.plt') ?
	exec(['-c', 'gnuplot -e ${ag('am.dat')} topdf.plt >/dev/null 2>&1'])
	os.rm('topdf.plt') ?
	os.rm('pm.dat') ?
	os.rm('am.dat') ?
}
